diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/model/packet.h ns-3.39/src/network/model/packet.h
--- ns-3.38/src/network/model/packet.h	2023-03-16 20:54:51.628957000 -0700
+++ ns-3.39/src/network/model/packet.h	2023-07-05 14:23:48.061428300 -0700
@@ -30,7 +30,6 @@
 
 #include "ns3/assert.h"
 #include "ns3/callback.h"
-#include "ns3/deprecated.h"
 #include "ns3/mac48-address.h"
 #include "ns3/ptr.h"
 
@@ -163,8 +162,8 @@
          * Constructor
          * \param data the data to copy.
          */
-        Item(const struct PacketTagList::TagData* data);
-        const struct PacketTagList::TagData* m_data; //!< the tag data
+        Item(const PacketTagList::TagData* data);
+        const PacketTagList::TagData* m_data; //!< the tag data
     };
 
     /**
@@ -183,9 +182,8 @@
      * Constructor
      * \param head head of the items
      */
-    PacketTagIterator(const struct PacketTagList::TagData* head);
-    const struct PacketTagList::TagData*
-        m_current; //!< actual position over the set of tags in a packet
+    PacketTagIterator(const PacketTagList::TagData* head);
+    const PacketTagList::TagData* m_current; //!< actual position over the set of tags in a packet
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/model/packet-metadata.cc ns-3.39/src/network/model/packet-metadata.cc
--- ns-3.38/src/network/model/packet-metadata.cc	2023-03-16 20:54:23.804869200 -0700
+++ ns-3.39/src/network/model/packet-metadata.cc	2023-07-05 14:23:48.061428300 -0700
@@ -77,7 +77,7 @@
 PacketMetadata::ReserveCopy(uint32_t size)
 {
     NS_LOG_FUNCTION(this << size);
-    struct PacketMetadata::Data* newData = PacketMetadata::Create(m_used + size);
+    PacketMetadata::Data* newData = PacketMetadata::Create(m_used + size);
     memcpy(newData->m_data, m_data->m_data, m_used);
     newData->m_dirtyEnd = m_used;
     m_data->m_count--;
@@ -142,7 +142,7 @@
     uint16_t current = m_head;
     while (ok && current != 0xffff)
     {
-        struct PacketMetadata::SmallItem item;
+        PacketMetadata::SmallItem item;
         PacketMetadata::ExtraItem extraItem;
         ReadItems(current, &item, &extraItem);
         ok &= IsSharedPointerOk(item.next);
@@ -375,7 +375,7 @@
 }
 
 uint16_t
-PacketMetadata::AddSmall(const struct PacketMetadata::SmallItem* item)
+PacketMetadata::AddSmall(const PacketMetadata::SmallItem* item)
 {
     NS_LOG_FUNCTION(this << item->next << item->prev << item->typeUid << item->size
                          << item->chunkUid);
@@ -507,7 +507,7 @@
     uint16_t current = m_head;
     while (current != 0xffff && current != m_tail)
     {
-        struct PacketMetadata::SmallItem tmpItem;
+        PacketMetadata::SmallItem tmpItem;
         PacketMetadata::ExtraItem tmpExtraItem;
         ReadItems(current, &tmpItem, &tmpExtraItem);
         uint16_t written = h.AddBig(0xffff, h.m_tail, &tmpItem, &tmpExtraItem);
@@ -523,8 +523,8 @@
 
 uint32_t
 PacketMetadata::ReadItems(uint16_t current,
-                          struct PacketMetadata::SmallItem* item,
-                          struct PacketMetadata::ExtraItem* extraItem) const
+                          PacketMetadata::SmallItem* item,
+                          PacketMetadata::ExtraItem* extraItem) const
 {
     NS_LOG_FUNCTION(this << current << item->chunkUid << item->prev << item->next << item->size
                          << item->typeUid << extraItem->fragmentEnd << extraItem->fragmentStart
@@ -563,7 +563,7 @@
     return buffer - &m_data->m_data[current];
 }
 
-struct PacketMetadata::Data*
+PacketMetadata::Data*
 PacketMetadata::Create(uint32_t size)
 {
     NS_LOG_FUNCTION(size);
@@ -574,7 +574,7 @@
     }
     while (!m_freeList.empty())
     {
-        struct PacketMetadata::Data* data = m_freeList.back();
+        PacketMetadata::Data* data = m_freeList.back();
         m_freeList.pop_back();
         if (data->m_size >= size)
         {
@@ -590,7 +590,7 @@
 }
 
 void
-PacketMetadata::Recycle(struct PacketMetadata::Data* data)
+PacketMetadata::Recycle(PacketMetadata::Data* data)
 {
     NS_LOG_FUNCTION(data);
     if (!m_enable)
@@ -610,18 +610,18 @@
     }
 }
 
-struct PacketMetadata::Data*
+PacketMetadata::Data*
 PacketMetadata::Allocate(uint32_t n)
 {
     NS_LOG_FUNCTION(n);
-    uint32_t size = sizeof(struct Data);
+    uint32_t size = sizeof(Data);
     if (n <= PACKET_METADATA_DATA_M_DATA_SIZE)
     {
         n = PACKET_METADATA_DATA_M_DATA_SIZE;
     }
     size += n - PACKET_METADATA_DATA_M_DATA_SIZE;
     uint8_t* buf = new uint8_t[size];
-    struct PacketMetadata::Data* data = (struct PacketMetadata::Data*)buf;
+    PacketMetadata::Data* data = (PacketMetadata::Data*)buf;
     data->m_size = n;
     data->m_count = 1;
     data->m_dirtyEnd = 0;
@@ -629,7 +629,7 @@
 }
 
 void
-PacketMetadata::Deallocate(struct PacketMetadata::Data* data)
+PacketMetadata::Deallocate(PacketMetadata::Data* data)
 {
     NS_LOG_FUNCTION(data);
     uint8_t* buf = (uint8_t*)data;
@@ -650,7 +650,6 @@
 PacketMetadata::AddHeader(const Header& header, uint32_t size)
 {
     NS_LOG_FUNCTION(this << &header << size);
-    NS_ASSERT(IsStateOk());
     uint32_t uid = header.GetInstanceTypeId().GetUid() << 1;
     DoAddHeader(uid, size);
     NS_ASSERT(IsStateOk());
@@ -666,7 +665,7 @@
         return;
     }
 
-    struct PacketMetadata::SmallItem item;
+    PacketMetadata::SmallItem item;
     item.next = m_head;
     item.prev = 0xffff;
     item.typeUid = uid;
@@ -682,14 +681,13 @@
 {
     uint32_t uid = header.GetInstanceTypeId().GetUid() << 1;
     NS_LOG_FUNCTION(this << &header << size);
-    NS_ASSERT(IsStateOk());
     if (!m_enable)
     {
         m_metadataSkipped = true;
         return;
     }
-    struct PacketMetadata::SmallItem item;
-    struct PacketMetadata::ExtraItem extraItem;
+    PacketMetadata::SmallItem item;
+    PacketMetadata::ExtraItem extraItem;
     uint32_t read = ReadItems(m_head, &item, &extraItem);
     if ((item.typeUid & 0xfffffffe) != uid || item.size != size)
     {
@@ -728,13 +726,12 @@
 {
     uint32_t uid = trailer.GetInstanceTypeId().GetUid() << 1;
     NS_LOG_FUNCTION(this << &trailer << size);
-    NS_ASSERT(IsStateOk());
     if (!m_enable)
     {
         m_metadataSkipped = true;
         return;
     }
-    struct PacketMetadata::SmallItem item;
+    PacketMetadata::SmallItem item;
     item.next = 0xffff;
     item.prev = m_tail;
     item.typeUid = uid;
@@ -751,14 +748,13 @@
 {
     uint32_t uid = trailer.GetInstanceTypeId().GetUid() << 1;
     NS_LOG_FUNCTION(this << &trailer << size);
-    NS_ASSERT(IsStateOk());
     if (!m_enable)
     {
         m_metadataSkipped = true;
         return;
     }
-    struct PacketMetadata::SmallItem item;
-    struct PacketMetadata::ExtraItem extraItem;
+    PacketMetadata::SmallItem item;
+    PacketMetadata::ExtraItem extraItem;
     uint32_t read = ReadItems(m_tail, &item, &extraItem);
     if ((item.typeUid & 0xfffffffe) != uid || item.size != size)
     {
@@ -796,7 +792,6 @@
 PacketMetadata::AddAtEnd(const PacketMetadata& o)
 {
     NS_LOG_FUNCTION(this << &o);
-    NS_ASSERT(IsStateOk());
     if (!m_enable)
     {
         m_metadataSkipped = true;
@@ -820,12 +815,12 @@
 
     // We read the current tail because we are going to append
     // after this item.
-    struct PacketMetadata::SmallItem tailItem;
+    PacketMetadata::SmallItem tailItem;
     PacketMetadata::ExtraItem tailExtraItem;
     uint32_t tailSize = ReadItems(m_tail, &tailItem, &tailExtraItem);
 
     uint16_t current;
-    struct PacketMetadata::SmallItem item;
+    PacketMetadata::SmallItem item;
     PacketMetadata::ExtraItem extraItem;
     o.ReadItems(o.m_head, &item, &extraItem);
     if (extraItem.packetUid == tailExtraItem.packetUid && item.typeUid == tailItem.typeUid &&
@@ -884,7 +879,6 @@
 PacketMetadata::RemoveAtStart(uint32_t start)
 {
     NS_LOG_FUNCTION(this << start);
-    NS_ASSERT(IsStateOk());
     if (!m_enable)
     {
         m_metadataSkipped = true;
@@ -895,7 +889,7 @@
     uint16_t current = m_head;
     while (current != 0xffff && leftToRemove > 0)
     {
-        struct PacketMetadata::SmallItem item;
+        PacketMetadata::SmallItem item;
         PacketMetadata::ExtraItem extraItem;
         ReadItems(current, &item, &extraItem);
         uint32_t itemRealSize = extraItem.fragmentEnd - extraItem.fragmentStart;
@@ -946,7 +940,6 @@
 PacketMetadata::RemoveAtEnd(uint32_t end)
 {
     NS_LOG_FUNCTION(this << end);
-    NS_ASSERT(IsStateOk());
     if (!m_enable)
     {
         m_metadataSkipped = true;
@@ -958,7 +951,7 @@
     uint16_t current = m_tail;
     while (current != 0xffff && leftToRemove > 0)
     {
-        struct PacketMetadata::SmallItem item;
+        PacketMetadata::SmallItem item;
         PacketMetadata::ExtraItem extraItem;
         ReadItems(current, &item, &extraItem);
         uint32_t itemRealSize = extraItem.fragmentEnd - extraItem.fragmentStart;
@@ -1015,7 +1008,7 @@
     uint16_t tail = m_tail;
     while (current != 0xffff)
     {
-        struct PacketMetadata::SmallItem item;
+        PacketMetadata::SmallItem item;
         PacketMetadata::ExtraItem extraItem;
         ReadItems(current, &item, &extraItem);
         totalSize += extraItem.fragmentEnd - extraItem.fragmentStart;
@@ -1072,9 +1065,9 @@
 PacketMetadata::ItemIterator::Next()
 {
     NS_LOG_FUNCTION(this);
-    struct PacketMetadata::Item item;
-    struct PacketMetadata::SmallItem smallItem;
-    struct PacketMetadata::ExtraItem extraItem;
+    PacketMetadata::Item item;
+    PacketMetadata::SmallItem smallItem;
+    PacketMetadata::ExtraItem extraItem;
     m_metadata->ReadItems(m_current, &smallItem, &extraItem);
     if (m_current == m_metadata->m_tail)
     {
@@ -1083,17 +1076,10 @@
     m_current = smallItem.next;
     uint32_t uid = (smallItem.typeUid & 0xfffffffe) >> 1;
     item.tid.SetUid(uid);
-    item.currentTrimedFromStart = extraItem.fragmentStart;
-    item.currentTrimedFromEnd = extraItem.fragmentEnd - smallItem.size;
+    item.currentTrimmedFromStart = extraItem.fragmentStart;
+    item.currentTrimmedFromEnd = extraItem.fragmentEnd - smallItem.size;
     item.currentSize = extraItem.fragmentEnd - extraItem.fragmentStart;
-    if (extraItem.fragmentStart != 0 || extraItem.fragmentEnd != smallItem.size)
-    {
-        item.isFragment = true;
-    }
-    else
-    {
-        item.isFragment = false;
-    }
+    item.isFragment = (extraItem.fragmentStart != 0 || extraItem.fragmentEnd != smallItem.size);
     TypeId tid;
     tid.SetUid(uid);
     if (uid == 0)
@@ -1143,8 +1129,8 @@
         return totalSize;
     }
 
-    struct PacketMetadata::SmallItem item;
-    struct PacketMetadata::ExtraItem extraItem;
+    PacketMetadata::SmallItem item;
+    PacketMetadata::ExtraItem extraItem;
     uint32_t current = m_head;
     while (current != 0xffff)
     {
@@ -1183,8 +1169,8 @@
         return 0;
     }
 
-    struct PacketMetadata::SmallItem item;
-    struct PacketMetadata::ExtraItem extraItem;
+    PacketMetadata::SmallItem item;
+    PacketMetadata::ExtraItem extraItem;
     uint32_t current = m_head;
     while (current != 0xffff)
     {
@@ -1287,8 +1273,8 @@
     buffer = ReadFromRawU64(m_packetUid, start, buffer, size);
     desSize -= 8;
 
-    struct PacketMetadata::SmallItem item = {0};
-    struct PacketMetadata::ExtraItem extraItem = {0};
+    PacketMetadata::SmallItem item = {0};
+    PacketMetadata::ExtraItem extraItem = {0};
     while (desSize > 0)
     {
         uint32_t uidStringSize = 0;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/model/packet-metadata.h ns-3.39/src/network/model/packet-metadata.h
--- ns-3.38/src/network/model/packet-metadata.h	2023-03-16 20:54:23.804869200 -0700
+++ ns-3.39/src/network/model/packet-metadata.h	2023-07-05 14:23:48.061428300 -0700
@@ -117,12 +117,12 @@
          * how many bytes were trimmed from the start of a fragment.
          * if isFragment is true, this field is zero.
          */
-        uint32_t currentTrimedFromStart;
+        uint32_t currentTrimmedFromStart;
         /**
          * how many bytes were trimmed from the end of a fragment.
          * if isFragment is true, this field is zero.
          */
-        uint32_t currentTrimedFromEnd;
+        uint32_t currentTrimmedFromEnd;
         /**
          * an iterator which can be fed to Deserialize. Valid only
          * if isFragment and isPayload are false.
@@ -512,7 +512,7 @@
     /**
      * \brief Class to hold all the metadata
      */
-    class DataFreeList : public std::vector<struct Data*>
+    class DataFreeList : public std::vector<Data*>
     {
       public:
         ~DataFreeList();
@@ -626,8 +626,8 @@
      * \returns the number of bytes read.
      */
     uint32_t ReadItems(uint16_t current,
-                       struct PacketMetadata::SmallItem* item,
-                       struct PacketMetadata::ExtraItem* extraItem) const;
+                       PacketMetadata::SmallItem* item,
+                       PacketMetadata::ExtraItem* extraItem) const;
     /**
      * \brief Add an header
      * \param uid header's uid to add
@@ -656,24 +656,24 @@
      * \brief Recycle the buffer memory
      * \param data the buffer data storage
      */
-    static void Recycle(struct PacketMetadata::Data* data);
+    static void Recycle(PacketMetadata::Data* data);
     /**
      * \brief Create a buffer data storage
      * \param size the storage size to create
      * \returns a pointer to the created buffer storage
      */
-    static struct PacketMetadata::Data* Create(uint32_t size);
+    static PacketMetadata::Data* Create(uint32_t size);
     /**
      * \brief Allocate a buffer data storage
      * \param n the storage size to create
      * \returns a pointer to the allocated buffer storage
      */
-    static struct PacketMetadata::Data* Allocate(uint32_t n);
+    static PacketMetadata::Data* Allocate(uint32_t n);
     /**
      * \brief Deallocate the buffer memory
      * \param data the buffer data storage
      */
-    static void Deallocate(struct PacketMetadata::Data* data);
+    static void Deallocate(PacketMetadata::Data* data);
 
     static DataFreeList m_freeList; //!< the metadata data storage
     static bool m_enable;           //!< Enable the packet metadata
@@ -689,7 +689,7 @@
     static uint32_t m_maxSize;  //!< maximum metadata size
     static uint16_t m_chunkUid; //!< Chunk Uid
 
-    struct Data* m_data; //!< Metadata storage
+    Data* m_data; //!< Metadata storage
     /*
        head -(next)-> tail
          ^             |
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/model/packet-tag-list.cc ns-3.39/src/network/model/packet-tag-list.cc
--- ns-3.38/src/network/model/packet-tag-list.cc	2023-03-16 20:54:23.804869200 -0700
+++ ns-3.39/src/network/model/packet-tag-list.cc	2023-07-05 14:23:48.061428300 -0700
@@ -67,9 +67,9 @@
 
     bool found = false;
 
-    struct TagData** prevNext = &m_next; // previous node's next pointer
-    struct TagData* cur = m_next;        // cursor to current node
-    struct TagData* it = nullptr;        // utility
+    TagData** prevNext = &m_next; // previous node's next pointer
+    TagData* cur = m_next;        // cursor to current node
+    TagData* it = nullptr;        // utility
 
     // Search from the head of the list until we find tid or a merge
     while (cur != nullptr)
@@ -151,7 +151,7 @@
         NS_ASSERT(cur != nullptr);
         NS_ASSERT(cur->count > 1);
         cur->count--; // unmerge cur
-        struct TagData* copy = CreateTagData(cur->size);
+        TagData* copy = CreateTagData(cur->size);
         copy->tid = cur->tid;
         copy->count = 1;
         copy->size = cur->size;
@@ -182,8 +182,8 @@
 bool
 PacketTagList::RemoveWriter(Tag& tag,
                             bool preMerge,
-                            struct PacketTagList::TagData* cur,
-                            struct PacketTagList::TagData** prevNext)
+                            PacketTagList::TagData* cur,
+                            PacketTagList::TagData** prevNext)
 {
     NS_LOG_FUNCTION_NOARGS();
 
@@ -227,8 +227,8 @@
 bool
 PacketTagList::ReplaceWriter(Tag& tag,
                              bool preMerge,
-                             struct PacketTagList::TagData* cur,
-                             struct PacketTagList::TagData** prevNext)
+                             PacketTagList::TagData* cur,
+                             PacketTagList::TagData** prevNext)
 {
     NS_LOG_FUNCTION_NOARGS();
 
@@ -244,7 +244,7 @@
         // cur is always a merge at this point
         // need to copy, replace, and link past cur
         cur->count--; // unmerge cur
-        struct TagData* copy = CreateTagData(tag.GetSerializedSize());
+        TagData* copy = CreateTagData(tag.GetSerializedSize());
         copy->tid = tag.GetInstanceTypeId();
         copy->count = 1;
         tag.Serialize(TagBuffer(copy->data, copy->data + copy->size));
@@ -263,12 +263,12 @@
 {
     NS_LOG_FUNCTION(this << tag.GetInstanceTypeId());
     // ensure this id was not yet added
-    for (struct TagData* cur = m_next; cur != nullptr; cur = cur->next)
+    for (TagData* cur = m_next; cur != nullptr; cur = cur->next)
     {
         NS_ASSERT_MSG(cur->tid != tag.GetInstanceTypeId(),
                       "Error: cannot add the same kind of tag twice.");
     }
-    struct TagData* head = CreateTagData(tag.GetSerializedSize());
+    TagData* head = CreateTagData(tag.GetSerializedSize());
     head->count = 1;
     head->next = nullptr;
     head->tid = tag.GetInstanceTypeId();
@@ -283,7 +283,7 @@
 {
     NS_LOG_FUNCTION(this << tag.GetInstanceTypeId());
     TypeId tid = tag.GetInstanceTypeId();
-    for (struct TagData* cur = m_next; cur != nullptr; cur = cur->next)
+    for (TagData* cur = m_next; cur != nullptr; cur = cur->next)
     {
         if (cur->tid == tid)
         {
@@ -296,7 +296,7 @@
     return false;
 }
 
-const struct PacketTagList::TagData*
+const PacketTagList::TagData*
 PacketTagList::Head() const
 {
     return m_next;
@@ -311,7 +311,7 @@
 
     size = 4; // numberOfTags
 
-    for (struct TagData* cur = m_next; cur != nullptr; cur = cur->next)
+    for (TagData* cur = m_next; cur != nullptr; cur = cur->next)
     {
         size += 4; // TagData -> size
 
@@ -348,7 +348,7 @@
         return 0;
     }
 
-    for (struct TagData* cur = m_next; cur != nullptr; cur = cur->next)
+    for (TagData* cur = m_next; cur != nullptr; cur = cur->next)
     {
         if (size + 4 <= maxSize)
         {
@@ -409,7 +409,7 @@
 
     NS_LOG_INFO("Deserializing number of tags " << numberOfTags);
 
-    struct TagData* prevTag = nullptr;
+    TagData* prevTag = nullptr;
     for (uint32_t i = 0; i < numberOfTags; ++i)
     {
         NS_ASSERT(sizeCheck >= 4);
@@ -427,7 +427,7 @@
 
         NS_LOG_INFO("Deserializing tag of type " << tid);
 
-        struct TagData* newTag = CreateTagData(tagSize);
+        TagData* newTag = CreateTagData(tagSize);
         newTag->count = 1;
         newTag->next = nullptr;
         newTag->tid = tid;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/model/packet-tag-list.h ns-3.39/src/network/model/packet-tag-list.h
--- ns-3.38/src/network/model/packet-tag-list.h	2023-03-16 20:54:23.804869200 -0700
+++ ns-3.39/src/network/model/packet-tag-list.h	2023-07-05 14:23:48.061428300 -0700
@@ -141,11 +141,11 @@
      */
     struct TagData
     {
-        struct TagData* next; //!< Pointer to next in list
-        uint32_t count;       //!< Number of incoming links
-        TypeId tid;           //!< Type of the tag serialized into #data
-        uint32_t size;        //!< Size of the \c data buffer
-        uint8_t data[1];      //!< Serialization buffer
+        TagData* next;   //!< Pointer to next in list
+        uint32_t count;  //!< Number of incoming links
+        TypeId tid;      //!< Type of the tag serialized into #data
+        uint32_t size;   //!< Size of the \c data buffer
+        uint8_t data[1]; //!< Serialization buffer
     };
 
     /**
@@ -217,7 +217,7 @@
     /**
      * \returns pointer to head of tag list
      */
-    const struct PacketTagList::TagData* Head() const;
+    const PacketTagList::TagData* Head() const;
     /**
      * Returns number of bytes required for packet serialization.
      *
@@ -266,8 +266,8 @@
      */
     typedef bool (PacketTagList::*COWWriter)(Tag& tag,
                                              bool preMerge,
-                                             struct TagData* cur,
-                                             struct TagData** prevNext);
+                                             TagData* cur,
+                                             TagData** prevNext);
     /**
      * Traverse the list implementing copy-on-write, using \pname{Writer}.
      *
@@ -287,7 +287,7 @@
      *          pointing to \pname{cur}.
      * \returns True, since tag will definitely be removed.
      */
-    bool RemoveWriter(Tag& tag, bool preMerge, struct TagData* cur, struct TagData** prevNext);
+    bool RemoveWriter(Tag& tag, bool preMerge, TagData* cur, TagData** prevNext);
     /**
      * Copy-on-write implementing Replace
      *
@@ -299,12 +299,12 @@
      *          pointing to \pname{cur}.
      * \returns True, since tag value will definitely be replaced.
      */
-    bool ReplaceWriter(Tag& tag, bool preMerge, struct TagData* cur, struct TagData** prevNext);
+    bool ReplaceWriter(Tag& tag, bool preMerge, TagData* cur, TagData** prevNext);
 
     /**
      * Pointer to first \ref TagData on the list
      */
-    struct TagData* m_next;
+    TagData* m_next;
 };
 
 } // namespace ns3
@@ -355,8 +355,8 @@
 void
 PacketTagList::RemoveAll()
 {
-    struct TagData* prev = nullptr;
-    for (struct TagData* cur = m_next; cur != nullptr; cur = cur->next)
+    TagData* prev = nullptr;
+    for (TagData* cur = m_next; cur != nullptr; cur = cur->next)
     {
         cur->count--;
         if (cur->count > 0)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/model/socket.h ns-3.39/src/network/model/socket.h
--- ns-3.38/src/network/model/socket.h	2023-03-16 20:54:23.808869100 -0700
+++ ns-3.39/src/network/model/socket.h	2023-07-05 14:23:48.061428300 -0700
@@ -162,11 +162,11 @@
      *         socket. Each socket's errno is initialized to zero
      *         when the socket is created.
      */
-    virtual enum Socket::SocketErrno GetErrno() const = 0;
+    virtual Socket::SocketErrno GetErrno() const = 0;
     /**
      * \return the socket type, analogous to getsockopt (SO_TYPE)
      */
-    virtual enum Socket::SocketType GetSocketType() const = 0;
+    virtual Socket::SocketType GetSocketType() const = 0;
     /**
      * \brief Return the node this socket is associated with.
      * \returns the node
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/test/examples-to-run.py ns-3.39/src/network/test/examples-to-run.py
--- ns-3.38/src/network/test/examples-to-run.py	2023-03-16 20:54:23.808869100 -0700
+++ ns-3.39/src/network/test/examples-to-run.py	2023-07-05 14:23:48.061428300 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/test/packet-metadata-test.cc ns-3.39/src/network/test/packet-metadata-test.cc
--- ns-3.38/src/network/test/packet-metadata-test.cc	2023-03-16 20:54:23.808869100 -0700
+++ ns-3.39/src/network/test/packet-metadata-test.cc	2023-07-05 14:23:48.061428300 -0700
@@ -372,7 +372,7 @@
     std::list<int> got;
     while (k.HasNext())
     {
-        struct PacketMetadata::Item item = k.Next();
+        PacketMetadata::Item item = k.Next();
         if (item.isFragment || item.type == PacketMetadata::Item::PAYLOAD)
         {
             got.push_back(item.currentSize);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/test/packet-test-suite.cc ns-3.39/src/network/test/packet-test-suite.cc
--- ns-3.38/src/network/test/packet-test-suite.cc	2023-03-16 20:54:23.808869100 -0700
+++ ns-3.39/src/network/test/packet-test-suite.cc	2023-07-05 14:23:48.061428300 -0700
@@ -548,7 +548,7 @@
 void
 PacketTest::DoCheck(Ptr<const Packet> p, uint32_t n, ...)
 {
-    std::vector<struct Expected> expected;
+    std::vector<Expected> expected;
     va_list ap;
     va_start(ap, n);
     for (uint32_t k = 0; k < n; ++k)
@@ -585,7 +585,7 @@
 void
 PacketTest::DoCheckData(Ptr<const Packet> p, uint32_t n, ...)
 {
-    std::vector<struct Expected> expected;
+    std::vector<Expected> expected;
     va_list ap;
     va_start(ap, n);
     for (uint32_t k = 0; k < n; ++k)
@@ -1119,11 +1119,15 @@
     { // Copy ctor, assignment
         std::cout << GetName() << "check copy and assignment" << std::endl;
         {
+            // Test copy constructor
+            // NOLINTNEXTLINE(performance-unnecessary-copy-initialization)
             PacketTagList ptl(ref);
             CheckRefList(ref, "copy ctor orig");
             CheckRefList(ptl, "copy ctor copy");
         }
         {
+            // Test copy constructor
+            // NOLINTNEXTLINE(performance-unnecessary-copy-initialization)
             PacketTagList ptl = ref;
             CheckRefList(ref, "assignment orig");
             CheckRefList(ptl, "assignment copy");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/utils/bit-deserializer.cc ns-3.39/src/network/utils/bit-deserializer.cc
--- ns-3.38/src/network/utils/bit-deserializer.cc	2023-03-16 20:54:23.808869100 -0700
+++ ns-3.39/src/network/utils/bit-deserializer.cc	2023-07-05 14:23:48.061428300 -0700
@@ -85,7 +85,7 @@
 BitDeserializer::PrepareDeserialization()
 {
     NS_LOG_FUNCTION(this);
-    if (m_deserializing == false)
+    if (!m_deserializing)
     {
         m_deserializing = true;
         for (auto index = m_bytesBlob.begin(); index != m_bytesBlob.end(); index++)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/utils/data-rate.h ns-3.39/src/network/utils/data-rate.h
--- ns-3.38/src/network/utils/data-rate.h	2023-03-16 20:54:51.628957000 -0700
+++ ns-3.39/src/network/utils/data-rate.h	2023-07-05 14:23:48.061428300 -0700
@@ -22,7 +22,6 @@
 
 #include "ns3/attribute-helper.h"
 #include "ns3/attribute.h"
-#include "ns3/deprecated.h"
 #include "ns3/nstime.h"
 
 #include <iostream>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/utils/ipv4-address.cc ns-3.39/src/network/utils/ipv4-address.cc
--- ns-3.38/src/network/utils/ipv4-address.cc	2023-03-16 20:54:23.808869100 -0700
+++ ns-3.39/src/network/utils/ipv4-address.cc	2023-07-05 14:23:48.065428300 -0700
@@ -77,14 +77,7 @@
 Ipv4Mask::IsMatch(Ipv4Address a, Ipv4Address b) const
 {
     NS_LOG_FUNCTION(this << a << b);
-    if ((a.Get() & m_mask) == (b.Get() & m_mask))
-    {
-        return true;
-    }
-    else
-    {
-        return false;
-    }
+    return (a.Get() & m_mask) == (b.Get() & m_mask);
 }
 
 uint32_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/utils/ipv4-address.h ns-3.39/src/network/utils/ipv4-address.h
--- ns-3.38/src/network/utils/ipv4-address.h	2023-03-16 20:54:51.628957000 -0700
+++ ns-3.39/src/network/utils/ipv4-address.h	2023-07-05 14:23:48.065428300 -0700
@@ -22,7 +22,6 @@
 
 #include "ns3/address.h"
 #include "ns3/attribute-helper.h"
-#include "ns3/deprecated.h"
 
 #include <ostream>
 #include <stdint.h>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/utils/ipv6-address.cc ns-3.39/src/network/utils/ipv6-address.cc
--- ns-3.38/src/network/utils/ipv6-address.cc	2023-03-16 20:54:23.808869100 -0700
+++ ns-3.39/src/network/utils/ipv6-address.cc	2023-07-05 14:23:48.065428300 -0700
@@ -552,22 +552,14 @@
 Ipv6Address::IsMulticast() const
 {
     NS_LOG_FUNCTION(this);
-    if (m_address[0] == 0xff)
-    {
-        return true;
-    }
-    return false;
+    return m_address[0] == 0xff;
 }
 
 bool
 Ipv6Address::IsLinkLocalMulticast() const
 {
     NS_LOG_FUNCTION(this);
-    if (m_address[0] == 0xff && m_address[1] == 0x02)
-    {
-        return true;
-    }
-    return false;
+    return m_address[0] == 0xff && m_address[1] == 0x02;
 }
 
 bool
@@ -610,11 +602,7 @@
     NS_LOG_FUNCTION(this);
 
     static Ipv6Address documentation("ff02::1:ff00:0");
-    if (CombinePrefix(Ipv6Prefix(104)) == documentation)
-    {
-        return true;
-    }
-    return false;
+    return CombinePrefix(Ipv6Prefix(104)) == documentation;
 }
 
 bool
@@ -652,11 +640,7 @@
 {
     NS_LOG_FUNCTION(this);
     static Ipv6Address documentation("2001:db8::0");
-    if (CombinePrefix(Ipv6Prefix(32)) == documentation)
-    {
-        return true;
-    }
-    return false;
+    return CombinePrefix(Ipv6Prefix(32)) == documentation;
 }
 
 bool
@@ -777,11 +761,7 @@
 {
     NS_LOG_FUNCTION(this);
     static Ipv6Address linkLocal("fe80::0");
-    if (CombinePrefix(Ipv6Prefix(64)) == linkLocal)
-    {
-        return true;
-    }
-    return false;
+    return CombinePrefix(Ipv6Prefix(64)) == linkLocal;
 }
 
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/utils/ipv6-address.h ns-3.39/src/network/utils/ipv6-address.h
--- ns-3.38/src/network/utils/ipv6-address.h	2023-03-16 20:54:51.628957000 -0700
+++ ns-3.39/src/network/utils/ipv6-address.h	2023-07-05 14:23:48.065428300 -0700
@@ -24,7 +24,6 @@
 
 #include "ns3/address.h"
 #include "ns3/attribute-helper.h"
-#include "ns3/deprecated.h"
 #include "ns3/ipv4-address.h"
 
 #include <cstring>
@@ -647,7 +646,7 @@
  * \brief Stream extraction operator.
  *
  * \param is the reference to the input stream
- * \param prefix the Ipv6Preofix
+ * \param prefix the Ipv6Prefix
  * \returns the reference to the input stream
  */
 std::istream& operator>>(std::istream& is, Ipv6Prefix& prefix);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/utils/lollipop-counter.h ns-3.39/src/network/utils/lollipop-counter.h
--- ns-3.38/src/network/utils/lollipop-counter.h	2023-03-16 20:54:23.808869100 -0700
+++ ns-3.39/src/network/utils/lollipop-counter.h	2023-07-05 14:23:48.065428300 -0700
@@ -182,11 +182,7 @@
      */
     bool IsInit() const
     {
-        if (m_value > m_circularRegion)
-        {
-            return true;
-        }
-        return false;
+        return m_value > m_circularRegion;
     }
 
     /**
@@ -200,11 +196,7 @@
         NS_ABORT_MSG_IF(lhs.m_sequenceWindow != rhs.m_sequenceWindow,
                         "Can not compare two Lollipop Counters with different sequence windows");
 
-        if (lhs.m_value == rhs.m_value)
-        {
-            return true;
-        }
-        return false;
+        return lhs.m_value == rhs.m_value;
     }
 
     /**
@@ -263,25 +255,11 @@
                      1; // this is guaranteed to be positive and between [1...m_lollipopMaxValue].
         if (distance > lhs.m_sequenceWindow)
         {
-            if (lhsIsHigher)
-            {
-                return true;
-            }
-            else
-            {
-                return false;
-            }
+            return lhsIsHigher;
         }
         else
         {
-            if (lhsIsHigher)
-            {
-                return false;
-            }
-            else
-            {
-                return true;
-            }
+            return !lhsIsHigher;
         }
 
         // this should never be reached.
